/*
 * log.c for MUDix - Enigma
 */
#include <conf.h>
#include <sys/time.h>
#include <ctype.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <ncurses.h>
#include <panel.h>
#include "mudix.h"

/* 
 * Locals
 */
FILE *fp_log = NULL;

/*
 * Externals
 */
extern time_t	current_time;

bool init_log(char *filename)
{
    if (fp_log) {
	do_status("Already logging!", 3);
	return FALSE;
    }
	
    strcat(filename, ".log");
    if (!(fp_log = fopen(filename, "a")))
	return FALSE;

    setbuf(fp_log, NULL);
    fprintf(fp_log, "%%%% STARTING NEW LOG, %s\n", ctime(&current_time));

    return TRUE;
} 

bool close_log(void)
{
    if (!fp_log) {
	do_status("Not logging yet.", 3);
	return FALSE;
    }

    fprintf(fp_log, "\n%%%% END OF LOG.\n");
    fclose(fp_log);
    fp_log = NULL;

    return TRUE;
}
	
void write_log(char *log_start, char *log_end)
{
    char *pLog = log_start;

    if (!fp_log)
	return;

    while (pLog < log_end) {
	if (*pLog == ESC) {
	    while (!isalpha(*pLog) && pLog < log_end)
		pLog++;
	}
	else if (*pLog == '\n' || isprint(*pLog))
	    fputc(*pLog, fp_log);

	pLog++;
    }  

    return;
}
