/*
 * parse.c for MUDix - Enigma
 */
#include <conf.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <ncurses.h>
#include <panel.h>
#include "mudix.h"

#define MAX_ARGS	10

char args_table[MAX_ARGS][MAX_STRING];

void build_arg_table(char *args)
{
    int i;

    for (i=0; i<MAX_ARGS; i++)
        args = get_arg(args, args_table[i]);	    
}

char *parse_input(char *src, char *args, char *dest, bool fReturn)
{
    char *pTmp;
    int   nested = 0;

    if (args)
	build_arg_table(args);

    while (*src != '\0') {
        if (*src == '{')	/* check for { } cos | is not valid then */
            nested++;
	else if (*src == '}')
	    nested--;
	else if (*src == '|' && nested == 0) {
	    src++;
	    fReturn = TRUE;
	    break;
	}

	if (*src != '%' || !args) {
	    *dest++ = *src++;    
            continue;
	}

	if (*(++src) == '\0')
	    break;
	if (!isdigit(*src))
	    continue;
	pTmp = args_table[*src - '0'];
        while (*pTmp != '\0')
	    *dest++ = *pTmp++;
	src++;
    }
    if (fReturn)
	*dest++ = '\n';
    *dest = '\0';

    return src;
}

char *get_arg(char *src, char *dst)
{
    int nested = 0;

    while (*src == ' ') /* strip leading spaces */
        src++;

    while (isprint(*src)) {
        if (*src == '{') {
            nested++;
	    if (nested == 1) {
		src++;
		continue;
	    }
	}
	else if (*src == '}') {
            nested--;
	    if (nested == 0) {
		src++;
		break;
	    }
	}
	else if (!nested && *src == ' ')
            break;

        *dst++ = *src++;
    }
    *dst++ = '\0';

    return src;
}

